﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;
using Telerik.WinControls;
using Telerik.WinControls.Data;
using Telerik.WinControls.UI;

namespace MCBExpirienceEnter
{
    public partial class Form1 : Form
    {
        private List<Customer> customerList;

        public Form1()
        {
            InitializeComponent();
        }

        private void FillForm()
        {
            this.customerList = Facade.GetCustomerList();

            if (this.mcbCustomer.MultiColumnComboBoxElement.Columns.Count == 0)
            {
                this.mcbCustomer.EditorControl.AutoGenerateColumns = false;
                this.mcbCustomer.MultiColumnComboBoxElement.DropDownWidth = 350;
                this.mcbCustomer.MultiColumnComboBoxElement.DropDownHeight = 150;
                this.mcbCustomer.EditorControl.EnableCustomSorting = false;
                this.mcbCustomer.EditorControl.EnableSorting = false;
                this.mcbCustomer.EditorControl.AutoSizeColumnsMode = GridViewAutoSizeColumnsMode.Fill;
                this.mcbCustomer.EditorControl.ShowRowHeaderColumn = false;
                this.mcbCustomer.DropDownStyle = RadDropDownStyle.DropDown;
                this.mcbCustomer.DisplayMember = "DisplayText";
                this.mcbCustomer.ValueMember = "Id";
                this.mcbCustomer.MultiColumnComboBoxElement.EditorControl.ShowFilteringRow = false;

                GridViewTextBoxColumn DisplayText = new GridViewTextBoxColumn();
                DisplayText.Name = "DisplayText";
                DisplayText.FieldName = "DisplayText";
                DisplayText.HeaderText = "DisplayText";
                DisplayText.DataType = typeof(string);
                DisplayText.IsVisible = false;
                DisplayText.VisibleInColumnChooser = false;

                GridViewTextBoxColumn NumberString = new GridViewTextBoxColumn();
                NumberString.Name = "NumberString";
                NumberString.FieldName = "NumberString";
                NumberString.HeaderText = "Number";
                NumberString.DataType = typeof(string);
                NumberString.Width = 30;

                GridViewTextBoxColumn Name = new GridViewTextBoxColumn();
                Name.Name = "Name";
                Name.FieldName = "Name";
                Name.HeaderText = "Name";
                Name.DataType = typeof(string);

                this.mcbCustomer.MultiColumnComboBoxElement.Columns.AddRange(DisplayText, NumberString, Name);

                FilterDescriptor fd = new FilterDescriptor("DisplayText", FilterOperator.StartsWith, string.Empty);
                fd.IsFilterEditor = false;
                this.mcbCustomer.MultiColumnComboBoxElement.EditorControl.Columns["DisplayText"].FilterDescriptor = fd;

                FilterDescriptor fd1 = new FilterDescriptor("NumberString", FilterOperator.StartsWith, string.Empty);
                fd1.IsFilterEditor = false;
                this.mcbCustomer.MultiColumnComboBoxElement.EditorControl.Columns["NumberString"].FilterDescriptor = fd1;

                FilterDescriptor fd2 = new FilterDescriptor("Name", FilterOperator.StartsWith, string.Empty);
                fd2.IsFilterEditor = false;
                this.mcbCustomer.MultiColumnComboBoxElement.EditorControl.Columns["Name"].FilterDescriptor = fd2;

                this.mcbCustomer.EditorControl.FilterDescriptors.LogicalOperator = FilterLogicalOperator.Or;
                this.mcbCustomer.MultiColumnComboBoxElement.AutoCompleteMode = AutoCompleteMode.SuggestAppend;
                this.mcbCustomer.AutoFilter = true;
                this.mcbCustomer.EditorControl.GridBehavior = new MyMultiColumnComboGridBehavior();

                this.mcbCustomer.DropDownClosed += new RadPopupClosedEventHandler(mcbCustomer_DropDownClosed);
                this.mcbCustomer.MultiColumnComboBoxElement.TextBoxElement.KeyDown += new KeyEventHandler(mcbCustomer_MultiColumnComboBoxElement_TextBoxElement_KeyDown);
            }

            this.mcbCustomer.DataSource = null;
            this.mcbCustomer.DataSource = this.customerList;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.FillForm();

        }

        private void mcbCustomer_DropDownClosed(object sender, RadPopupClosedEventArgs args)
        {
            if (this.mcbCustomer.EditorControl.CurrentRow != null && this.mcbCustomer.EditorControl.CurrentRow.DataBoundItem != null)
            {
                Customer cust = this.mcbCustomer.EditorControl.CurrentRow.DataBoundItem as Customer;

                if (cust == null)
                    return;

                int index = this.customerList.IndexOf(cust);

                this.mcbCustomer.SelectedIndex = index;
                this.mcbCustomer.Text = cust.DisplayText;
                this.mcbCustomer.Invalidate(true);
            }
        }

        private void mcbCustomer_MultiColumnComboBoxElement_TextBoxElement_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                e.SuppressKeyPress = true;
                e.Handled = true;
                this.mcbCustomer.MultiColumnComboBoxElement.ClosePopup();
            }
        }

        private void btTest_Click(object sender, EventArgs e)
        {

        }
    }
}
